#!/bin/bash

# Define the URLs to block
URLS_TO_BLOCK=(
    "www.example.com"
    "www.facebook.com"
    
)

# Check if running with root privileges
if [ "$EUID" -ne 0 ]; then
    echo "Please run the script with root privileges (sudo)."
    exit 1
fi

# Open the hosts file for editing
hosts_file="/etc/hosts"
temp_file="/tmp/hosts.tmp"
cp "$hosts_file" "$temp_file"

# Add the URLs to block in the hosts file
for url in "${URLS_TO_BLOCK[@]}"; do
    if ! grep -q -E "^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\s+$url$" "$temp_file"; then
        echo "127.127.0.0 $url" >> "$temp_file"
    fi
done

# Replace the original hosts file with the modified version
mv "$temp_file" "$hosts_file"

# Flush the DNS cache by restarting the networking service
systemctl restart NetworkManager

echo "Blocked the specified URLs successfully."